//   "MSP430 z pamici FRAM"                                         // konfiguracja "MSP-EXP430FR5739":
//   Zadanie numer 6.1. Obsuga wejcia. Tryb pollingu.               // ( ustawienia fabryczne )
//                                                                    // w programie wykorzystano
//                              ACLK   nieaktywny                     // zainstalowany w module 
//                              MCLK = SMCLK = DCOCLK ~1MHz           // przycisk S1, oraz diode LED1
//                                                                    // 
//                           MSP430FR5739                             // dziaanie programu:
//                           -----------------                        // wcinicie przycisku S1
//                         |                 |                        // wcza diod  LED1
//                  S1 ->  | P4.0       PJ.0 | -> LED1                // zwolnienie przycisku S1
//                         |                 |                .K.'13 // wycza diod LED1
//------------------------------------------------------------------- //    
                                                                      // pliki nagwkowe
#include "io430.h"                                                    // rejestry procesora 
                                                                      //
void main( void )                                                     // program gwny     
{                                                                     //
  WDTCTL = WDTPW + WDTHOLD;                                           // zatrzymaj ukad Watchdog 
                                                                      // 
                                                                      // konfiguracja linii we/wy 
  P1OUT = 0x00; P2OUT = 0x00; P3OUT = 0x00; P4OUT = 0x00;             // ustaw stan niski na liniach 
  PJOUT = 0x00;                                                       // ( wszystkie linie pracuj w    
                                                                      // trybie we/wy, PxSELx wyzerowane )
  P1DIR = 0xff; P2DIR = 0xff; P3DIR = 0xff; P4DIR = 0xff;             // ustaw linie w kierunku wyjcia 
  PJDIR = 0xff;                                                       //                      
                                                                      // konfiguracja P4.0
  P4OUT |=   BIT0;                                                    // ( wejcie "pull-up" )  
  P4REN |=   BIT0;                                                    // wcz rezystor podcigajcy 
  P4DIR &=~  BIT0;                                                    // ustaw linie w kierunku wejcia 
                                                                      //
                                                                      //  
 while(1)                                                             // ptla gwna programu 
 {                                                                    //  
       if( !(P4IN & BIT0) )                                           // sprawd stanu przycisku S1  
       {                                                              // 
           PJOUT |=  BIT0;                                            // * gdy przycisk jest wcinity 
       }                                                              // - wcz diod LED1      
       else                                                           //                              
       {                                                              // * gdy przycisk jest zwolniony
           PJOUT &=~ BIT0;                                            // - wycz diod LED1 
       }                                                              //  
  };                                                                  // 
}                                                                     //    
