//   "MSP430 z pamici FRAM"                                         // konfiguracja "MSP-EXP430FR5739": 
//   Zadanie numer 6.1. Obsuga wejcia. Tryb przerwa.               // ( ustawienia fabryczne )
//                                                                    // w programie wykorzystano
//                              ACLK   nieaktywny                     // zainstalowany w module 
//                              MCLK = SMCLK = DCOCLK ~1MHz           // przycisk S1, oraz diode LED1
//                                                                    // 
//                           MSP430FR5739                             // dziaanie programu:
//                           -----------------                        // wcinicie przycisku S1
//                         |                 |                        // wcza diod  LED1
//                  S1 ->  | P4.0       PJ.0 | -> LED1                // zwolnienie przycisku S1
//                         |                 |                .K.'13 // wycza diod LED1
//------------------------------------------------------------------- //    
                                                                      // pliki nagwkowe
#include "io430.h"                                                    // rejestry procesora 
#include "intrinsics.h"                                               // instrukcje procesora 
                                                                      //
void main( void )                                                     // program gwny     
{                                                                     //
  WDTCTL = WDTPW + WDTHOLD;                                           // zatrzymaj ukad Watchdog 
                                                                      // 
                                                                      // konfiguracja linii we/wy 
  P1OUT = 0x00; P2OUT = 0x00; P3OUT = 0x00; P4OUT = 0x00;             // ustaw stan niski na liniach 
  PJOUT = 0x00;                                                       // ( wszystkie linie pracuj w        
                                                                      // trybie we/wy, PxSELx wyzerowane )  
  P1DIR = 0xff; P2DIR = 0xff; P3DIR = 0xff; P4DIR = 0xff;             // ustaw linie w kierunku wyjcia   
  PJDIR = 0xff;                                                       //                                  
                                                                      // konfiguracja P4.0
  P4OUT |=   BIT0;                                                    // ( wejcie "pull-up" )             
  P4REN |=   BIT0;                                                    // wcz rezystor podcigajcy       
  P4DIR &=~  BIT0;                                                    // ustaw linie w kierunku wejcia         
                                                                      // ( obsuga przerwa )
  P4IES |=   BIT0;                                                    // ustaw zbocze wyzwalajce ( 1->0 )  
  P4IFG &=~  BIT0;                                                    // zeruj flag przerwania 
  P4IE  |=   BIT0;                                                    // wcz obsug przerwania
                                                                      //
 __bis_SR_register(GIE);                                              // odblokowanie przerwa maskowalnych
                                                                      //
 while(1)                                                             // ptla gwna programu 
 {                                                                    //  
                                                                      // wcz tryb upienia LPM4   
   __bis_SR_register( LPM4_bits );              	              // sygnay zegarowe s wyczone
                                                                      // tylko odwieanie SRAM
                                                                      //
     PJOUT |=  BIT0;                                                  // wcz  diod LED1      
     while(!(P4IN & BIT0));                                           // czekaj dopki S1 jest wcinity 
     PJOUT &=~  BIT0;                                                 // wycz diod LED1    
  };                                                                  // 
}                                                                     //    
                                                                      //
#pragma vector=PORT4_VECTOR                                           // procedura obsugi przerwania 
__interrupt void Port_4(void)                                         // port P4 (linie P4.0 oraz P4.1)
{                                                                     // 
  switch(__even_in_range(P4IV,4))                                     // sprawd warto rejestru P4IV  
  {                                                                   //   
    case  2:                                                          // P4.0                              
                                                                      // po wyjciu z procedury obsugi  
           __bic_SR_register_on_exit( LPM4_bits );                    // przerwania, wyjd z trybu LPM4  
             break;                                                   // 
    case  4: break;                                                   // P4.1                
    default: break;                                                   // brak obsugi  
  }					                              //  
}                                                                     //          
